"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createExampleAsyncCache = exports.createExampleSyncCache = void 0;
const createExampleSyncCache = () => {
    const store = {};
    const cache = {
        set: (key, value, options) => {
            store[key] = options ? { value, options } : { value };
        },
        get: (key) => { var _a; return (_a = store[key]) === null || _a === void 0 ? void 0 : _a.value; },
    };
    return { cache, store };
};
exports.createExampleSyncCache = createExampleSyncCache;
const createExampleAsyncCache = () => {
    const store = {};
    const cache = {
        set: (key, value, options) => __awaiter(void 0, void 0, void 0, function* () {
            // eslint-disable-next-line no-nested-ternary
            store[key] =
                value !== undefined
                    ? options
                        ? { value, options }
                        : { value }
                    : undefined;
        }),
        get: (key) => __awaiter(void 0, void 0, void 0, function* () { var _a; return (_a = store[key]) === null || _a === void 0 ? void 0 : _a.value; }),
    };
    return { cache, store };
};
exports.createExampleAsyncCache = createExampleAsyncCache;
//# sourceMappingURL=createExampleCache.js.map